package org.codehaus.mojo.hibernate3;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on hibernate3-maven-plugin.<br/> Call <pre>  mvn hibernate3:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Sun Feb 05 12:32:33 PST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:hibernate3-maven-plugin:3.0", 0 );
        append( sb, "", 0 );

        append( sb, "Hibernate3 Maven Plugin", 0 );
        append( sb, "Hibernate Tools is a toolset for Hibernate 3 and related projects. The tools provide Maven plugins for performing reverse engineering, code generation and interaction with Hibernate.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 12 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "hbm2cfgxml".equals( goal ) )
        {
            append( sb, "hibernate3:hbm2cfgxml", 0 );
            append( sb, "\'hbm2cfgxml\' generates a hibernate.cfg.xml. Intended to be used together with a \'jdbcconfiguration\' when performing reverse engineering, but can be used with any kind of configuration. The \'hbm2cfgxml\' will contain the properties used and adds mapping entries for each mapped class.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "hbm2dao".equals( goal ) )
        {
            append( sb, "hibernate3:hbm2dao", 0 );
            append( sb, "\'hbm2dao\' generates a set of DAOs.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "hbm2ddl".equals( goal ) )
        {
            append( sb, "hibernate3:hbm2ddl", 0 );
            append( sb, "\'hbm2ddl\' lets you run schemaexport and schemaupdate which generates the appropriate SQL DDL and allow you to store the result in a file or export it directly to the database. Remember that if a custom naming strategy is needed it is placed on the configuration element.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "hbm2doc".equals( goal ) )
        {
            append( sb, "hibernate3:hbm2doc", 0 );
            append( sb, "\'hbm2doc\' generates html documentation a\'la javadoc for the database schema.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "hbm2hbmxml".equals( goal ) )
        {
            append( sb, "hibernate3:hbm2hbmxml", 0 );
            append( sb, "\'hbm2hbmxml\' generates a set of .hbm files. Intended to be used together with a \'jdbcconfiguration\' when performing reverse engineering, but can be used with any kind of configuration. e.g. to convert from annotation based pojo\'s to hbm.xml.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "hbm2java".equals( goal ) )
        {
            append( sb, "hibernate3:hbm2java", 0 );
            append( sb, "\'hbm2java\' is a java code generator. Options for controlling wether JDK 5 syntax can be used and wether the POJO should be annotated with EJB3/Hibernate Annotations.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "hbmlint".equals( goal ) )
        {
            append( sb, "hibernate3:hbmlint", 0 );
            append( sb, "\'hbmlint\' scans mappings for errors.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "hbmtemplate".equals( goal ) )
        {
            append( sb, "hibernate3:hbmtemplate", 0 );
            append( sb, "\'hbmtemplate\' generic exporter that can be controlled by a user provided template or class.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "hibernate3:help", 0 );
            append( sb, "Display help information on hibernate3-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0hibernate3:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "instrument".equals( goal ) )
        {
            append( sb, "hibernate3:instrument", 0 );
            append( sb, "Goal for \'cglib\' or \'javassist\' instrumentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "instrument", 2 );
                append( sb, "The \'instrument\' element containing the plugin configuration.", 3 );
                append( sb, "Expression: ${instrument}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "query".equals( goal ) )
        {
            append( sb, "hibernate3:query", 0 );
            append( sb, "\'query\' is used to execute a HQL query statements and optionally send the output to a file. Can be used for verifying the mappings and for basic data extraction.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run".equals( goal ) )
        {
            append( sb, "hibernate3:run", 0 );
            append( sb, "\'AntRun\' wrapper.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classRealm", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin.classRealm}", 3 );
                append( sb, "", 0 );

                append( sb, "hibernatetool", 2 );
                append( sb, "The \'hibernatetool\' element containing the plugin configuration.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${hibernatetool}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
